/***********************************************************************
*
	Virtual Villagers (Desktop version for Windows and Mac)
	Copyright  2005, 2006 LDW Software, LLC

	Project started (for desktop builds) November 2005.
	Project beta: June 15, 2006
	Project completed: July 12, 2006

	Built on PTK game engine, using LDW Custom Framework (designed by Arthur Humphrey and Greg Hospelhorn) in Jan/Feb 2006.
	//Possible framework names: Helios, Silicon..?

	Version Notes:
	//.65	Last pre-alpha version?  Splash, loading, intro screens in.  Game saves/loads. Most AI and bevmacs in. realtime in.
	// 954 beta3
	// 955 beta3 fixed
	// 956 bfg beta
	// 960 gamezebo
	// 961 cleaned up bfg version (out to portals?)
	// 962 oberon preview
	// 970 beta 4
	// 971 bfg beta1 (portal demo)
	// 100 GM BFG initial launch
    // 1000 Brandable build.  fixed GM bits
	// 1002 oberon
	// 1004 yahoo
	// 1005 real
	// 1006 aol, shockwave
	// 1007 iwin
	// 1008 ldw press copy
	// 1009 gamehouse pc / gameFiesta?!
	// 1011 game fiesta (probably not used...)
	// 1012 arcade town
	// 1013 playfirst
	// 1017 BFG mac
	// 1018 mac game store
	// 1019 gamehouse MAC build
	// 1020 ldw mac demo
	// 1021 ldw mac full
	// 1047 german oberon
	// 1048 german real
	// 1046 german zylom
	// 1045 german BFG
	// 1044 german boonty
	// 1088 spanish versions
	// 1022 spin top games
	// 1053 oberon french
	// 1055 real direct
	// 1056 popcap
	// 1057 steam

***********************************************************************/
#include "ldwTypes.h"

#if !defined(ISOLA_H_)
#define ISOLA_H_

/***********************************************************************
*
*	Build Settings
*
***********************************************************************/

#define cLdwVersion							1017

#define cDistributor						ldw

//setting to german is for all foreign languages
#define language							ldwEnglish

#define cDebug								false

#define cDemo								true

#define cDevCodes							false

#define cLogging							true

#define cSplashScreenEnabled				true

#define cSplashScreenDelay					4 //in seconds

#define cTraceOutput						true

#define canExpire							false

const ldwDate cExpirationDate = {8,31,2010};

const bool cLaunchOnExitUrl =				false;

#ifndef _MAC
//#define ON_EXIT_URL "steam://store/7300"
#define ON_EXIT_URL "http://www.ldw.com/vv_win_buy/index.html"
#endif

#ifdef _MAC
#define ON_EXIT_URL "http://www.ldw.com/vv_mac_buy/index.html" //put plimus cart here
#endif


//version notes
//950 beta 1
//951 special portal preview build

/***********************************************************************
 *
 *	Entry Points
 *
 ***********************************************************************/
#define appFileCreator				'LDWB'
#define appPrefID						0
#define appSavedGameID				0
#define appPrefVersion				2
#define appSavedGameVersion			1
#define appDBType					'vssg'
#define appDBAtts					dmHdrAttrBackup
#define version30						0x03000000
#define version40						0x04000000
#define version50						0x05000000

/***********************************************************************
 *
 *	Constants 
 *
 ***********************************************************************/
//#define DEBUG					false
//#define FULLSCREENBLIT			false
//#define DEBUG2                  false		//specific debugs: game is registered, cheats enabled
//#define DEBUG3 					false		// report island events
//#define DEBUG_CEMETERY			false		//for cemetery debugs
//#define SOUNDQ_DEBUG			false		//for new sound mgr debugs
//#define BTesterDebug			false
//#define distributor				ldw
//#define registered					true

#define numFramesWalkingAnim		8

#define playerMessageDuration		5
#define shortPlayerMessageDuration 1

#define maxNumVillagers			256
#define widthOfWorld			1680
#define heightOfWorld			1680

#define maxNumWaitingPopups		10
#define maxNumWaitingDealerSays	10

#define chanceOfTwins			7
#define chanceOfTriplets		25

//resource offsets
#define bodySetOffset			15
#define headSetOffset			8
#define childSetOffset			8
#define bodyOffsetBetweenDirections	8
#define headOffsetBetweenDirections 1
#define bodyOffsetToBent			10
#define bodyOffsetToSitting			11
#define bodyOffsetToWorking			8

#define numSecondsAutoPause			31000

//#define minutesPerAge				1
#define dailyCheckInterval			360 //in seconds

#define ABSOLUTECHECKDATE_DAY		1
#define ABSOLUTECHECKDATE_MONTH		1
#define ABSOLUTECHECKDATE_YEAR		2003

#define BETAEXPIRE_DAY				7
#define BETAEXPIRE_MONTH			1
#define BETAEXPIRE_YEAR				2007

#define maxOffTime					15  //number of seconds the game can be off or in sleep without adjusting sprite positions, etc

#define maxNumGameStates			99

#define maxNameSize					13 //this regarding hotsync id

#define startingSkillValue			20
#define traineeSkillLevel			20
#define adeptSkillLevel				50
#define masterSkillLevel			90
#define minPredisposedSkillLevel	1	//skill level at which a peep will keep trying to do what they were told

#define baseTechTick				100
#define bonusTechTick				50

#define level1ResearchTick			7
#define level2ResearchTick			1
#define techResearchBonus			2

#define totalResearchPointsToLevel	1000
#define totalResearchPercentDivisor 10  //these two have to work together to make a % complettion. eg: 1000 / 10 = 100; ok!

#define foodLowLevel				50
#define foodOKLevel					400
#define foodAbundantLevel			2000

#define maxNumLikes					4
#define maxAvailableLikes			46

#define foodConsumptionRate			2 //units per peep per age (approx 10 ages per hour)
#define pregnancyModifier			300 // (ex 300 = .33 chance for master breeder to impregnate)
#define agesUntilAdult				280
#define agesUntilFertile			360
#define agesUntilElderly 			1000
#define agesOfPregnancy				40
#define agesPerVisibleAge			20
#define agesUntilMortality			1100
#define medicineLongevityBonus		8

#define smallPopulationLimit		7
#define mediumPopulationLimit		15
#define largePopulationLimit		30
//#define absoluteSmallHeapPopLimit	30
#define absolutePopLimit			90

//font and text output
#define widthOfScreen               160
#define avgFloatCharWidth           3.65
#define spaceWidth					5
#define lineSpacing 				8
#define leftMargin					3
//custom window defs
#define widthOfSideFramePiece		2
#define heightOfSideFramePiece		2
#define heightOfTopFramePiece		2
#define heightOfBtmFramePiece		2
#define widthOfTopFramePiece		2

#define maxWidth					154
#define maxHeight					154
#define customWinBackColor          164

#define embraceOffsetDef			5

//message window
#define msgOKButtonX				108
#define msgOKButtonY				126
#define msgOKButtonWidth			56
#define msgOKButtonHeight			20
// puzzle stat window
#define puzzleOKButtonX				118
#define puzzleOKButtonY				135
#define puzzleOKButtonWidth			28
#define puzzleOKButtonHeight		10
#define stat2PuzzButtonX			88
#define stat2PuzzButtonY			135
#define stat2PuzzButtonWidth		28
#define stat2PuzzButtonHeight		10
#define puzzTextStartY				32
#define puzzDescX					17
#define puzzTimeX					107
#define puzzTitleY					18
#define puzzAchievementX			40
#define puzzHRSX					90
/*
#define statsHoursXPos				17
#define statsHoursYPos				32

*/
//GameEventWindow
#define longButton1X				20
#define longButton1Y				124
#define longButton2X				20
#define longButton2Y				136
#define longButtonWidth				120
#define longButtonHeight			10


//DESCISION MODIFIERS
#define chanceOfNotUsingSkill		15
#define chanceOfNotWorking			15
#define motivatorModifier			40
#define chanceOfDoingNothing		65
#define chanceOfCrabs				20

#define chanceOfMatingWhileHungry	25

//volume settings
#define auroraSoftMusicLevel		100
#define auroraNormalMusicLevel		210
#define auroraLoudMusicLevel		500
#define auroraHalfSoftMusicLevel	105
#define auroraHalfNormalMusicLevel	50
#define auroraHalfLoudMusicLevel	250


//offscreen buffer defs
#define offscreenTrim				18

#define widthOfOffScreenWin			200 
#define heightOfOffScreenWin		160	

//#define topLeftBlitAreaX			2
//#define topLeftBlitAreaY			2
//#define widthOfBlitArea				156
//#define heightOfBlitArea			112

#define dragBoundryNorth			6
#define dragBoundryWest				3
#define dragBoundryEast				154
#define dragBoundrySouth			110

//integer directions..
#define intNortheast					0
#define intSoutheast					1
#define intSouthwest					2
#define intNorthwest					3
#define intHeadSouthSoutheast			4
#define intHeadSouth					5
#define intHeadSouthSouthwest			6


//int enums for skill types
#define intSkillNULL				0
#define intSkillFarming				1
#define intSkillBreeding			2
#define intSkillResearch			3
#define intSkillConstruction		4
#define intSkillHealing				5

//predisposed behavior enums
#define preNULL						0
#define preBlockage					1
#define preGarden					2
#define preBerries					3
#define preResearch					4
#define preFarming					5
#define preFishing					6
#define preDebris					7
#define preTemple					8
#define preHealing					9
#define preBreeding					10
#define preHut1						11
#define preHut2						12
#define preHut3						13
#define preIdol						14

//int enums for tech types
#define intTechNULL					0
#define intTechFood					1
#define intTechResearch				2
#define intTechConstruction			3
#define intTechSpirituality			4
#define intTechFertility			5
#define intTechMedicine				6

#define messageDuration				5  //...in seconds
#define hotSpotMessageDuration		2

#define maxNumAlertsDef				40

#define tipOffset					1100

#define secondsBetweenAlertsDef		1

#define maxNumItems					20

//#define maxNumTips					52  //tutorial tips
//#define firstTipRsc					1400
//MESSAGE AND TUTORIAL TIPS
/*
#define tipNULL						0
#define tipFirstThing				1
#define tipFirstFailure				3 //should be in focus villager
#define tipFirstSuccess				4 //should be in focus
#define tipFirstMapDrag				5  //put in the pen up if possible, else in the pen move
#define tipSuccessOverviewUsage		7 //this always set false at game start!!
#define tipFirstTrainee				8 //can we find and set focus?
#define tipFirstAdept				9 //can we find and set focus?
#define tipFirstMaster				10 //set focus? explain bonus
#define tipFirstSick				11
#define tipFirstPreg				12
#define tipFirstBaby				13
#define tipFoodOk					14
#define tipFirstSelect				17
#define tipFirstVillagerDrag		18
#define tipFirstSkillPref			20
#define tipFirstDetailToggle		21
#define tipFinishedPartOne			22
#define tipFirstFailedResearch		23
#define tipFirstSuccessResearch		24
#define tipFirstResearchScreen		25
#define tipFirstPartTwo				26
#define tipFirstFailedBreeding		27
#define tipFirstSuccessBreeding		28
#define tipFirstFirstFailedHealing	29
#define tipFirstSuccessHealing		30
#define tipFirstDeath				31
#define tipOverviewIntro			32
#define tipAddlMapDrag				33
#define tipBerryGood				34
#define tipFirstDetail				35
#define tipFirstFailedHealing		36

#define tipYouLose					38
*/
//boon and bane firing flags tell if a boon or bane has been 'used'
//#define tipDummyBaneResearch		40
//#define tipDummyBoonBabies			41
//#define tipDummyBaneMeasles			42
//#define tipBerriesLow				47
//#define tipPopMilestoneSmall		43
//#define tipPopMilestoneMed			44
//#define tipPopMilestoneLarge		45
/*
#define tipLastTipSetAutoOn			79

#define puzzleCaveOpened			83
#define puzzleLagoonCleared			84
#define puzzleBeachCleaned			85
#define puzzleGardenRestored		86
#define puzzleTreasureFound			87
#define puzzlePathFound				88
#define puzzleIdolCarved			89
#define puzzleTempleRebuilt			90
#define puzzleRightHutBuilt			91
#define puzzleBottomLeftHutBuilt	92
#define puzzleCemetaryActivated		93
#define puzzleGoldenChildBorn		94
#define	welcomeVillage				95
#define InternalUse					96
#define tipTERMINATOR				99
*/
//non-tip messages
//#define	rightHutDone			100
//#define	farmingResearch			101
//#define	buriedTreasure			102


//#define trialPopCap					101
//#define absolutePopCap              102

#define firstCommonChoiceCrisis     104
#define numCommonChoiceCrises		6  // this has to be the number of entries below, up to the last commmon (this is an extremely shitty construct)
#define	gameEventWhale				104

#define	gameEventBerry				105
#define gameEventCrate				106
#define funkyDrumCrisis				107
#define furryFoodCrisis				108
#define theYellowJar				109

#define firstRareChoiceCrisis		132
#define numRareChoiceCrises			4 //this has to be the number of entries below, up to the last rare (this is an extremely shitty construct)
#define theRedPhial					132
#define plantTycoonCrisis			133
#define mysteriousFaceCrisis		134
#define theBluePhial                135

#define firstNoChoiceCrisis			150
#define firstCommonNoChoiceCrisis   151
#define numCommonNoChoiceCrises		5  // this has to be the number of entries below, up to the last commmon (this is an extremely shitty construct)
#define gameCrisisBadMonkey			151
#define gameCrisisGoodMonkey		152
#define gameCrisisStorm				153
#define gameCrisisGreedyMonkey		154
#define berryPlagueCrisis			155


#define firstRareNoChoiceCrisis   	161
#define numRareNoChoiceCrises		3 //this has to be the number of entries below, up to the last rare (this is an extremely shitty construct)
#define anotherShipwreck			161	
#define badAngryMonkey				162	
#define fishOfFertility				163

#define lastNoChoiceCrisis			180
//choice crisis soloutions
#define firstABCrisisResolution		200
#define	gameEventWhaleA				201
#define	gameEventWhaleB				202

#define	gameEventBerryA				203
#define	gameEventBerryB				204

#define	gameEventCrateA				205
#define gameEventCrateB				206

#define plantTycoonCrisisA			207
#define plantTycoonCrisisB			208

#define funkyDrumCrisisA			209
#define funkyDrumCrisisB			210

#define furryFoodCrisisA			211
#define furryFoodCrisisB			212

#define mysteriousFaceCrisisA		213
#define mysteriousFaceCrisisB		214

#define theRedPhialA				215
#define theRedPhialB				216

#define theBluePhialA				217
#define theBluePhialB				218

#define theYellowJarA				219
#define theYellowJarB				220

#define baneContaminatedExpA		221
#define baneContaminatedExpB		222
 

#define lastABCrisisResolution		289
//end choice crisis soln's

#define firstBane					500
#define numBanes					3
#define baneMeasles					500 //sickens or kills children (base + rnd 30%)
#define baneDrought					501 // freeze food production?
#define baneLocusts					502 
//#define baneBarrelOfWoe				503 // mysteriousCrate - random anti food plague/ sickness/ demote peep  @skill level

//#define baneBarrelOfMonkies			506 //destructive bane(ruin buildings/structures)

#define firstBoon					700
#define numBoons					3
#define boonGenius					700 //randomChild gets master researcher
#define boonBerryBees				701
#define boonBarrelOBabies			702
//#define boonDiscovery				701 // + tech points (base + rnd (CorrectForLevel())
//#define boonBarrelOfPlenty			702 // mysterious crate model that yields food bonus's

#define lastBoon					899
#define firstChoiceBane				900
#define numChoiceBanes				1
#define baneContaminatedExp         900

#define firstChoiceBoon				950
#define numChoiceBoons				0

#define messageTerminator			999
//END MESSAGE AND TTIP DEFS

#define tipTextParagraphOffset		0
#define tipDragTrigger				150 //this is mod'd agains the scrolling coord to trigger after dragging a while

#define numSecondsBetweenComments	15

//screen position defines


//STATS DEFS
#define statsHoursXPos				17
#define statsHoursYPos				32 //was 32
#define statsBornXPos				17
#define	statsBornYPos				40 //was 40
#define statsBuriedXPos				17
#define statsBuriedYPos				56 //was 48
#define statsOldestXPos				17
#define statsOldestYPos				64 //was 56
#define statsMaxPopXPos				17
#define statsMaxPopYPos				72 //was 64
#define statsFoodXPos				17
#define statsFoodYPos				80 //was 72
#define statsTechPtsXPos			17
#define statsTechPtsYPos			96 //was 80
#define statsTechLvlXPos			17
#define statsTechLvlYPos			104 //was 88
#define statsNumCrisesXPos			17
#define statsNumCrisesYPos			112 //was 96
#define statsPuzzlesXPos			17
#define statsPuzzlesYPos			120 //was 104
#define statsCuredXPos				17
#define statsCuredYPos				48 //was 112
#define statsCrabsXPos				17
#define statsCrabsYPos				88 //was 120

#define statsHoursValXPos			117
#define statsBornValXPos			117
#define statsBuriedValXPos			117
#define statsOldestValXPos			117
#define statsMaxPopValXPos			117
#define statsFoodValXPos			117
#define statsTotalFoodValXPos       117
#define statsTechPtsValXPos			117
#define statsTechLvlValXPos			117
#define statsNumCrisesValXPos		117
#define statsPuzzlesValXPos			117
#define statsCuredValXPos			117
#define statsCrabsValXPos			117

#define statTickDelay				15
#define statsSnd                    DripSnd

#define maxTombStones				50

//OVERVIEW MAP defs
#define overviewBlitAreaX			1
#define overviewBlitAreaY			1
#define widthOfOverviewBlitArea		158
#define heightOfOverviewBlitArea	134
//OVERVIEW MAP DECAL DEFS
#define lagoonMiniX					13
#define lagoonMiniY					15
#define idolMiniX					34
#define idolMiniY					43
#define treasureMiniX				100
#define treasureMiniY				120
#define hut1MiniX					80
#define hut1MiniY					83
#define hut2MiniX					22
#define hut2MiniY					72
#define hut3MiniX					22
#define hut3MiniY					93
#define foodMiniX					103
#define foodMiniY					97
#define cropsMini1X					34
#define cropsMini2X					46
#define cropsMini3X					57
#define cropsMiniY					108
#define templeMiniX					125
#define templeMiniY					106
#define gardenMiniX					126
#define gardenMiniY					64
#define caveOpenMiniX				96
#define caveOpenMiniY				0
#define tablewareMiniX				57
#define tablewareMiniY				85



#define dealerSayY   				151 //we will not user dealerSayX cuz we'll center the text.
#define dealerSayX					2
#define mapNorthBoundryDef			1
#define mapSouthBoundryDef			1600
#define mapEastBoundryDef			1540
#define mapWestBoundryDef			8

#define townCenterX					300
#define townCenterY					240
#define mainVillagerNameFieldX		34
#define mainVillagerNameFieldY		118
#define mainVillagerTaskFieldX		34
#define mainVillagerTaskFieldY		140
#define mainVillagerSkillFieldX		34
#define mainVillagerSkillFieldY		129

#define overviewPopFieldX			46
#define overviewPopFieldY			140
#define overviewFoodFieldX			89
#define overviewFoodFieldY			140

#define mainLicenseAreaX			0
#define mainLicenseAreaY			114
//buttons
#define widthOfNavButton			27		
#define heightOfNavButton			9


//about screen

#define aboutLine1Y					17
#define aboutLeftMargin				3
#define aboutLineFeed				6
#define JBotXPos					5
#define	JBotYPos					141
#define AuroraXPos					94
#define AuroraYPos					129

//main village detail license
#define mainVillageFoodFieldX		58
#define mainVillageFoodFieldY		117
#define mainVillagePopFieldX		58
#define mainVillagePopFieldY		128
#define mainVillageDiseaseFieldX	58
#define mainVillageDiseaseFieldY	137

//villager detail screen
#define villagerDoneButtonX			128
#define villagerDoneButtonY			135
#define villagerwidthOfDoneButton	29
#define villagerheightOfDoneButton	10

#define villagerFarmingCheckboxX		146
#define villagerFarmingCheckboxY		74
#define villagerResearchCheckboxX		146
#define villagerResearchCheckboxY		86
#define villagerBreedingCheckboxX		146
#define villagerBreedingCheckboxY		98
#define villagerHealingCheckboxX		146
#define villagerHealingCheckboxY		110
#define villagerConstructionCheckboxX	146
#define villagerConstructionCheckboxY	122
#define villagerWidthOfCheckbox			10
#define villagerHeightOfCheckbox		10

#define villagerLeftArrowButtonX		4
#define villagerLeftArrowButtonY		41
#define villagerRightArrowButtonX		21
#define villagerRightArrowButtonY		41
#define villagerWidthOfLeftRightButton	7
#define villagerHeightOfLeftRightButton	10


//prefs defs
#define prefsBGWidth			151
#define prefsBGHeight			151		
#define prefsTitleTxtY			15
#define prefsMusicTxtX			47
#define prefsMusicTxtY			46
#define prefsMusicOnTxtX		86
#define prefsMusicOffTxtX		108
#define prefsSoundTxtX			46
#define prefsSoundTxtY			29
#define prefsSounOnTxtX			86
#define prefsSounOffTxtX		109
#define prefsMusicVolTxtX		18
#define prefsMusicVolTxtY		62
#define prefsMusicVolRow2		72
#define prefsDifficultyX		35
#define prefsDifficultyY		88
#define prefsDifficultyRow2		98
#define prefsGameSpeedTxtX		25
#define prefsGameSpeedTxtY		113
#define prefsSpeedCommonX		86
#define prefsPauseY				83
#define prefsSlowY				92
#define prefsNormalY			101
#define prefsFastY				110
#define prefsGSRow2				123
#define prefsOKBtnX				90
#define prefsOKBtnY				140
#define prefsCancelBtnX			122
#define prefsCancelBtnY			140

#define prefsTxtColumn1			80
#define prefsTxtColumn2			115

#define prefsCBColumn1			72
#define prefsCBColumn2			107
#define prefsCBRow1				28
#define prefsCBRow2				45
#define prefsCBRow3				61
#define prefsCBRow4				71
#define prefsCBRow5				88
#define prefsCBRow6				97
#define prefsCBRow7				112
#define prefsCBRow8				122
#define prefsCBWidth			30
#define prefsCBHeight			7

//preference value tokens


#define musicEnabled   			true
#define musicDisabled			false
#define soundEnabled			true
#define soundDisabled			false
#define musicVolLow				0
#define musicVolNorm			1
#define musicVolHi				2
#define difficultyLow			0
#define difficultyNorm			1
#define difficultyHi			2
#define gameSpeedPaused			999
#define gameSpeedSlow			10
#define gameSpeedNorm			6			
#define gameSpeedFast			3


//story2 defs
#define story2YesBtnX		96
#define story2YesBtnY		142
#define story2NoBtnX		126
#define story2NoBtnY		142
#define	story2BtnWidth		28
#define	story2BtnHeight		10

//Stats Defs
#define	statsOKBtnX			118
#define statsOKBtnY			135	
#define statsOKBtnWidth		28
#define statsOKBtnHeight	10


#define puzzleR1			25
#define puzzleR2			57
#define puzzleR3			89		

#define puzzleC1			20
#define puzzleC2			52
#define puzzleC3			84
#define puzzleC4			116

#define puzzleTileWidth		26
#define puzzleTileHeight	26

#define puzzleMsgY			123

#define puzzleEraseX		13
#define puzzleEraseY 		117
#define puzzleEraseWidth	135
#define puzzleEraseHeight	17

// sound manager stuff
//#define soundPlayTime 		6 //in seconds		
#define soundArrayLength    7
//end soundManager stuff

//NEW research Defs
#define noTechFocus					999
#define harvestTechPrices           0
#define buildingTechPrices			1
#define medsTechPrices				2
#define scienceTechPrices			3
#define fertTechPrices				4
#define spiritTechPrices			5

#define harvestPrice2				6000
#define harvestPrice3				50000
#define buildingPrice2				5000
#define buildingPrice3				70000
#define medsPrice2					15000
#define medsPrice3					250000
#define sciencePrice2				12000
#define sciencePrice3				150000
#define fertPrice2					11000
#define fertPrice3					240000
#define spiritPrice2				5000
#define spiritPrice3				80000

#define focusXIdx					0
#define focusYIdx					1
#define focusFrame1X				1
#define focusFrame1Y				24
#define focusFrame2X				80 // was 80
#define focusFrame2Y				24
#define focusFrame3X				1
#define focusFrame3Y				61
#define focusFrame4X				80 // was 80
#define focusFrame4Y				61
#define focusFrame5X				1
#define focusFrame5Y				99 //was 98
#define focusFrame6X				80 // was 80
#define focusFrame6Y				99
#define focusFrameWidth				79
#define focusFrameHeight			37

#define researchPointsX				99
#define researchPointsY				15
#define researchDoneButtonX			128
#define researchDoneButtonY			135
#define researchBuyButtonX			100
#define researchBuyButtonY			135
#define researchInfoButtonX         8
#define researchInfoButtonY			135
#define researchWidthOfDoneButton	29
#define researchHeightOfDoneButton	10
#define harvestLine1Y				46
#define harvestLine1AX				5
#define harvestLine1BX				56
#define harvestLine2Y				54
#define harvestLine2AX				5
#define harvestLine2BX				25
#define harvestLine2CX				31
#define harvestLine2DX				37
#define harvestLine2EX				64

#define buildingLine1Y				46
#define buildingLine1AX				83 //add 78 to first column
#define buildingLine1BX				134
#define buildingLine2Y				54
#define buildingLine2AX				83
#define buildingLine2BX				103
#define buildingLine2CX				109
#define buildingLine2DX				115
#define buildingLine2EX				142

#define medicineLine1Y				83
#define medicineLine1AX				5
#define medicineLine1BX				56
#define medicineLine2Y				91
#define medicineLine2AX				5
#define medicineLine2BX				25
#define medicineLine2CX				31
#define medicineLine2DX				37
#define medicineLine2EX 			64

#define scienceLine1Y				83
#define scienceLine1AX				83
#define scienceLine1BX				134
#define scienceLine2Y				91
#define scienceLine2AX				83
#define scienceLine2BX				103
#define scienceLine2CX				109
#define scienceLine2DX				115
#define scienceLine2EX 				142

#define fertilityLine1Y				120
#define fertilityLine1AX			5
#define fertilityLine1BX			56
#define fertilityLine2Y				128
#define fertilityLine2AX			5
#define fertilityLine2BX			25
#define fertilityLine2CX			31
#define fertilityLine2DX			37
#define fertilityLine2EX 			64


#define spiritLine1Y				120
#define spiritLine1AX				83
#define spiritLine1BX				134
#define spiritLine2Y				128
#define spiritLine2AX				83
#define spiritLine2BX				103
#define spiritLine2CX				109
#define spiritLine2DX				115
#define spiritLine2EX 				142

//options
#define optionsNewGameButtonX		35
#define optionsNewGameButtonY		62
#define	optionsContinueButtonX		35
#define optionsContinueButtonY		50
#define optionsRegisterButtonX		35
#define optionsRegisterButtonY		119
#define optionsAboutButtonX			35
#define optionsAboutButtonY			108
#define optionsBeamButtonX			35
#define optionsBeamButtonY			96
#define optionsPrefsButtonX			35
#define optionsPrefsButtonY			73	
#define optionsStatsButtonX			35
#define optionsStatsButtonY			85
#define optionsButtonWidth			68
#define optionsButtonHeight			11
#define optionsContinueDecalX		35
#define optionsContinueDecalY		52
#define optionsRegisterDecalX		34
#define optionsRegisterDecalY		120

// yes/no dialog
#define yesButtonX					52
#define yesButtonY					83
#define noButtonX					82
#define noButtonY					83
#define yesNoButtonWidth			28
#define yesNoButtonHeight			10
#define yesNoPopupWidth				67
#define yesNoPopupHeight			35

//intro2

//main
#define optionsButtonX				131
#define optionsButtonY				136

#define mapButtonX					130
#define mapButtonY					115

#define researchButtonX				130
#define researchButtonY				125

#define villagerDetailButtonX		101
#define villagerDetailButtonY		115

#define maxNameLength				25
//overview
//research
//villager
//stats
//prefs

//end screen position defines

#define redrawInterval				4
#define slowRedrawInterval			20

//peeps defines
#define widthOfPeeps				40 //12//18
#define heightOfPeeps				65 //20//32

#define peepNameSize				30
//skin defs
#define bodyYOffset					5 //(pixels)
#define haloYOffset					17
#define maxNumPSprites				70 //debug this is temp
#define peepSwimmingOffset			12
#define headSittingOffset			5

#define overviewMapOffsetX			175
#define overviewMapOffsetY			41

#define maxNumEnvironSounds			8

//end peep defs

//sprites, anim rates
#define minSpriteVel				10
#define maxSpriteVel				75
#define spriteAnimRate				7 //num of iterations to keep a anim cell on sprite
#define headShakeRate				7

#define numBendingFrames			4

//  ARTHUR defines
#define SecondsPerHour				1800//1800  //this is set to real-time 1/2 hours now
#define HoursPerDay					16//12 //this is set to 12 "game hours" per displayed pet age. with 1/2 hours that's 6 hours per day.
#define HoursUntilAdult				144//72
#define HoursUntilElderly			816//336
#define HoursUntilMortal			1152//336
#define MaxHoursOldAge				336//240 //each hour there is a 1 in MaxHoursOldAge - (years of old age) chance of dying, after mortality

//font manager defs
#define letterResourceStartDef 		8800
#define maxScreenXDef  				160
#define letterResourceOffsetDef 	1
// meter mode defs
#define meterMode_SolidRed			1
#define	meterMode_SolidGrn			2		
#define	meterMode_SolidBlue			3
#define meterMode_SolidYel			4
#define meterMode_SolidBlk			5
#define meterMode_SolidPurp			6
#define	meterMode_GradRedGrn		10
#define meterMode_GradGrnRed		11
#define meterMode_GradRedBlue       12
#define meterMode_GradBlueRed       13
#define meterMode_SolidBlueLt		14
#define meterMode_SolidBlueXtraLt	15

//WORLD STATE INT DEFS (These replace enums. guaranteed ints)
#define	caveOpened					1
#define	lagoonCleared				2
#define	beachCleaned				3
#define	gardenRestored				4
#define	treasureFound				5
#define	pathFound					6
#define	idolCarved					7
#define	templeRebuilt				8
#define rightHutBuilt				9
#define topLeftHutBuilt				10
#define bottomLeftHutBuilt			11
#define cemeteryActivated			12
#define goldenChildBorn				13
#define berriesAdded				14
#define cropsAdded					15
#define fishAdded					16
#define crabAdded					17
#define advanceResearch				18
#define failedGarden				19
#define farmsDiscovered				20 //these 2 added for stats achievement tracking
#define fishingDiscovered			21 
#define schoolFounded				22
#define wellOpened					23
#define bloodroseFound				24
#define cactusFound					25
#define lilyFound					26
#define ballplantFound				27
#define herbsMastered				28
#define butterfliesCalled			29
#define magicFishFound				30
#define magicPlantFound				31	
#define mushroomAdded				32
#define rareMushroomAdded			33
#define maxNumPuzzleDefs			35

#define makeBerries					37
#define makeCrops					38
#define makeFood					39
#define makeDanceparty				40
#define eating						41
#define pickingShroom				42

//misc
#define goldenChildName				199
#define genderNULL					0
#define genderMale 					1
#define genderFemale 				2

#define noSpriteInHand 		-99
#define noSpriteInFocus		-99
//#define heldSpritePosition  149
#define firstButterflyIndex	0
#define maxNumButterflies	10
#define firstFloatingAnimIndex		20
#define maxNumFloatingAnimations	30

#define totalFloatingAnimations		50

#define dragSensitivity		3  //how many pixels to drag, to 'grab' a sprite, not just give focus?
// List of key bindings


#define baseLearningRate			30  //percent chance of a complete noob succeeding at a task.

#define chanceOfUsingpreferredSkill  85  //percent
#define chanceOfSkippingProject		 20
#define chanceOfRecuperating		50
#define chanceOfDiseaseDamage		70
#define chanceOfStarvationDamage	75
#define chanceOfRare				50
#define chanceOfChoiceCrisis		50
#define chanceOfNoChoiceCrisis		50
#define chanceOfGoldenChildBirth	10
#define chanceOfElderlyDisease		14 //(once every 12 hours at normal)
#define chanceOfVocationalInjury	2
#define chanceOfSpell				30
#define chanceOfBenignSpell			25

#define chanceOfBoonBane			15

#define healthMercyLevel			20
#define vocationalMaxDamage			15

#define hoursOfFreePlayAloud		48

#define farmRefreshInterval			40 //in ages.  should replenish every (40 * 6) minutes
#define farmRefreshAmount			800
	
#define berryRefreshAmount			30
#define enoughBerriesToPick			100

#define corpseDecayTime				240//DEBUG temp 24 hr...120 ages or 12 real hours
#define	maxNumCharsInMessage		1024
#define messageQueueLength			20

#define berriesStartingAmount		1400

//puzzle completion settings
#define idolCarvedPoints			1350
#define rightHutBuiltPoints			250
#define topLeftHutBuiltPoints		400
#define bottomLeftHutBuiltPoints	600
#define beachCleanedPoints			150
#define lagoonClearedPoints			350
#define gardenRestoredPoints		200
#define treasureFoundPoints			800
#define magicPlantCompletionPoints  300
#define wellOpenedPoints			2
#define templeRebuiltPoints			1000


#define firstCrisisHours 			1
//debug make these longer duration
#define normalCrisisHours			12

// Note that these two characters are currently virtual, and thus the
// code handling them checks for the command bit in the event record.

#define music1Def					1
#define music2Def					2
#define introMusicDef				3
#define noMusicInstalled			9

#define farmingLevel2Price			6000
#define farmingLevel3Price			50000
#define spiritualityLevel2Price		5000
#define spiritualityLevel3Price		80000
#define buildingLevel2Price			2500
#define buildingLevel3Price			80000
#define scienceLevel2Price			12000
#define scienceLevel3Price			150000
#define fertilityLevel2Price		11000
#define fertilityLevel3Price		240000
#define medicineLevel2Price			15000
#define medicineLevel3Price			250000


//old mystery defs


/***********************************************************************
 *
 *	Internal Structures
 *
 ***********************************************************************/

typedef enum
{
	eGreenCanvas,
	eRedCanvas,
	eOrangeCanvas,
	eNoColor
} DialogColorEnum;	

typedef enum
{
	ldwEnglish,
	ldwGerman
} LanguageEnum;

typedef enum
{
	eNULLScene,
	eMain,
	eMenu,
	eSplash,
	eOverview,
	eTech,
	eVillager,
	eMessage,
	eUpdatingWorld,
	eAbout,
	ePopupYesNo,
	eRegistration,
	ePrefs,
	eStats,
	eYesNoDialog,
	eStory1,
	eStory2,
	ePuzzles,
	eGameEvent,
	eReg,
	eGamewin,
	eIntro1,
	eIntro2,
	eLoading,
	eHelp,
	eEndGame
	

} GameSceneEnum;	


//END PC MAC FRAMEWORK STRUCTS NEW NEW

/*
typedef struct
{
	int month; 
	int day; 
	int year; 

} LDWDateType;

*/

typedef enum
	{
	ldw,
	palmgear,
	handango,
	bfg,
	generic,
	aol,
	real,
	iwin,
	yahoo,
	oberon,
	steam,
	spintop,
	zylom,
	popcap,
	zylomReal,
	boonty,
	shockwave,
	macgamesstore,
	gamehouse,
	gamefiesta,
	playfirst,
	arcadetown

	} DistributorEnum;

typedef struct
	{
		char  name[maxNameLength];
		int skillVal;
		int bestSkill;
		int age;
		int gender;

	} TombStoneType;

typedef struct
	{
	int progress;
	bool completed;
	
	} WorldStateType;
    

typedef struct
	{
		int level;
		int progress;
		
	} TechType;
	    
typedef struct
	{
		//SndPtr soundHandle;
		unsigned long terminationTime;
		
	} SoundTimerListType;	
	    
typedef struct
	{
	
	TechType	spirituality;
	TechType	science;
	TechType	construction;
	TechType	medicine;
	TechType 	fertility;
	TechType	food; 
		
	} ResearchStateType;
	
typedef struct PointType {
	int x;
	int y;
} PointType;


typedef struct
	{
	int numFrames;
	int startBM;
	int currentFrame;
	PointType pos;
	} AnimationType;	

//SPRITE

//PSPRITE DUMP AREA
typedef struct
	{
	int breeding;
	int construction;
	int farming;
	int healing;
	int research;
	
	int preferredSkill;
	
	} SkillsType;

typedef struct
	{
	
	unsigned long secondsAccumilated;
	unsigned long lastTimeChecked;
	
	int health;
	int age;
	int agesChecked;
	int gender;
	int disease;
	int pregnancyStartTime;
	int twins;
	int headType;
	int bodyType;
	int fName;
	int lName;

	char firstName[maxNameLength];

	//int happiness;
	
	int fatherSkillType;
	int fatherSkillValue;
	int fatherLName;
	
	int likes[maxNumLikes];
	int dislikes[maxNumLikes];

	int predisposition; //predisposed to do what last told if relevant
	
	} BioType;

typedef struct
	{
	BioType bio;
	SkillsType skills;
	bool exists;
	} PSpriteDumpType;
	
typedef struct
	{
	long gameStartTime;
	long pointsEarned;
	int babiesMade;
	long foodGathered;
	int peepsCured;
	int crabsFound;
	int maxPop;
	int peepsDied;
	int oldestVillager;
	int numCrisis;
	int numTwins;
	int numTriplets;

	ldwUINT32 completionTimes[maxNumPuzzleDefs + 1];
	
	} StatsType;


/*
//MAINVARTYPE. this is the main game var, all this info will be saved in prefs.
typedef struct
{

	bool hasShutDown;
	bool firstTime;
	bool firstTime2;
	
	bool reallyFirstTime;
	//bool isDead;
	//bool isSick;
	bool haltSprites;
	bool waitIntro;
	
	bool sounds;
	bool music;	
	int musicVol;
	int difficulty;
	int minutesPerAge;
	unsigned int crisisTimer;
	
	long techPoints;
	
	char regCode[10];
	
	StatsType stats;
	
	unsigned long currentTime;
	//UINT32 lastNagTime;
	//UINT32 farmRefreshTimer;
	unsigned long farmTimer;
	GameScreenEnum currentScreen;
	
	long food;
	long health;
	int berriesRemaining;
	int cropsRemaining;

	bool registered;
		
	bool tutorialTip[tipTERMINATOR + 1];
	
	PSpriteDumpType pSpriteDump[maxNumPSprites + 1];
	
	WorldStateType worldState[maxNumGameStates + 1];
	
	ResearchStateType researchState;

	TombStoneType tombStoneList[maxTombStones];	

} MainVarType;

//old structs below...



typedef struct
	{
	unsigned int initDelay;
	unsigned int period;
	unsigned int doubleTapDelay;
	bool queueAhead;
	} KeyRateType;

typedef struct
{
	bool sound;	
	bool music;
	int musicVol;
	int difficulty;
	int speed;
	
} PrefsTempStructType;


//#define noItemSelection			-1

*/

#define randN(N)	ldwGameState::GetRandom(N)

#endif
